/*
	Copyright (C) 2012-2030

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//#pragma once
#ifndef __DJOYSTICKS_H__
#define __DJOYSTICKS_H__

#include <iostream>
#include <vector>

#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

using namespace std;


class DJoySticks
{
public:
	static IDirectInput8* dev;									// the main DirectInput device

	static std::vector<LPDIRECTINPUTDEVICE8> gameControllers;

	
	static std::vector<DIJOYSTATE> gameControllerStates;
	
	static std::vector<DIDEVCAPS> capabilities;
	
	static HWND joy_hWnd;
	static HINSTANCE joy_hInstance;

	static BOOL CALLBACK staticEnumerateGameControllers(LPCDIDEVICEINSTANCE devInst, LPVOID pvRef);
	static BOOL CALLBACK staticSetGameControllerAxesRanges(LPCDIDEVICEOBJECTINSTANCE devObjInst, LPVOID pvRef);
	
	bool Init ( HWND hWnd, HINSTANCE hInstance );
	
	// re-initialize using the hWnd and hInstance that was already supplied
	bool ReInit ();
	
	bool Update( int iPadNum );
	
	bool Release ();
};

#endif	// end #ifndef __DJOYSTICKS_H__
